/* ******************************************************* *
 *      byteOrder : test of the swab_type function         *
 *                                                         *
 * ******************************************************* */

#include <stdlib.h>
#include <stdio.h>

long swab_type()
{
	union swabtest {
		unsigned long l;
		unsigned char c[4];
	} swabtest;

	swabtest.l = 0xaabbccdd;

	if ((swabtest.c[0] == 0xaa) && (swabtest.c[1] == 0xbb) &&
	    (swabtest.c[2] == 0xcc) && (swabtest.c[3] == 0xdd))  {
		/* BIG_ENDIAN: Do nothing */
		return 0;
	}
	else if ((swabtest.c[0] == 0xdd) && (swabtest.c[1] == 0xcc) &&
	    (swabtest.c[2] == 0xbb) && (swabtest.c[3] == 0xaa))  {
		/* LITTLE_ENDIAN */
		return 1;
	}
	else if ((swabtest.c[0] == 0xbb) && (swabtest.c[1] == 0xaa) &&
	    (swabtest.c[2] == 0xdd) && (swabtest.c[3] == 0xcc))  {
		/* PDP_ENDIAN */
		return 2;
	}
	else  {
		/* Unknown */
		return -1;
	}
}

int main(int argCnt, char ** argVct)
  {
   int byte_order;

   byte_order = swab_type();
 
   printf("Byte order(%d) : ", byte_order);

   switch ( byte_order) {
    case  0 : printf("Big Endian\n");
              break;
    case  1 : printf("Little Endian\n");
              break;
    case  2 : printf("PDP Endian\n");
              break;
    default : printf("Unknown\n");
              break;
    }
  
   return 0;
  }
