/* *************************************** *
 * gnisQueue.c : stack for gnis file args  *
 *                                         *
 * *************************************** */

#include "gnisQueue.h"
#include "stdlib.h"

typedef struct {
             char *gnis_file;
             void *prevPtr;
}gnisQueueStruct;

gnisQueueStruct *queue;

void initGnisQueue()
{
  queue = malloc(sizeof(gnisQueueStruct));
  queue->gnis_file = NULL;
  queue->prevPtr   = NULL;
}

void loadGnisQueue(char *fileName)
{
  gnisQueueStruct *temp;

  if (queue->gnis_file != NULL) {
    temp = queue;

    queue = malloc(sizeof(gnisQueueStruct));
    queue->gnis_file = NULL;
    queue->prevPtr   = (void *)temp;
  }
  queue->gnis_file = fileName;
}

char *unloadGnisQueue()
{
  gnisQueueStruct *temp;
  char            *gnis_file;

  if ((queue == NULL) || (queue->gnis_file == NULL)) {
    return NULL;
  }

  gnis_file = queue->gnis_file;

  if (queue->prevPtr != NULL) {
    temp = queue;
  
    queue = (gnisQueueStruct *)(temp->prevPtr);
    free(temp);
  }
  else {
    free(queue);
    queue = NULL;
  }

  return gnis_file;
}
